{% load static %}
<!DOCTYPE html>
<html>
<head>
    <!--Import Google Icon Font-->
    <link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">
    <!--Import materialize.css-->
    <title>Cari Tempat Wisata</title>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/css/materialize.min.css">
    <link href="https://fonts.googleapis.com/css?family=Montserrat" rel="stylesheet">
    <link rel="stylesheet" href="{% static 'css/style.css' %}">
    <!--Let browser know website is optimized for mobile-->
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
</head>

<body>
<div>
    <div class="sidebar">
        <p class="sidebar-title"><strong>MENGENAL WISATA INDONESIA</strong></p>
        <form id="find" action="{% url 'search' %}" method="get" enctype="multipart/form-data">
            {% csrf_token %}
            <div class="row">
                <div class="col s12">
                    <div class="row">
                        <div class="input-field col s12">
                            <i class="material-icons prefix sidebar-icons">my_location</i>
                            <input type="text" id="start" name="start" class="autocomplete">
                            <label for="autocomplete-input">Lokasi Awal</label>
                        </div>
                    </div>
                    <div class="row">
                        <div class="input-field col s12">
                            <i class="material-icons prefix sidebar-icons">place</i>
                            <input type="text" id="goal" name="goal" class="autocomplete">
                            <label for="autocomplete-input">Destinasi</label>
                        </div>
                    </div>
                    <div class="row">
                        <div class="input-field col s12 tourism"></div>
                    </div>
                    <div class="row">
                        <div class="input-field col s12" id="finder">
                            <button class="btn-large waves-effect waves-light search" type="submit"
                                    name="action">Cari
                                <i class="material-icons right">search</i>
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </form>
    </div>
    <div id="map"></div>
</div>


<!--JavaScript at end of body for optimized loading-->
<script
        src="https://code.jquery.com/jquery-3.3.1.js"
        integrity="sha256-2Kok7MbOyxpgUVvAk/HJ2jigOSYS2auK4Pfzbm7uH60="
        crossorigin="anonymous"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/js/materialize.min.js"></script>
<script>
    const data = {
        "bandung": null,
        "jakarta": null,
        "karawang": null,
        "indramayu": null,
        "cirebon": null,
        "brebes": null,
        "pekalongan": null,
        "garut": null,
        "tasikmalaya": null,
        "purwokerto": null,
        "magelang": null,
        "boyolali": null,
        "semarang": null,
        "solo": null,
        "jogja": null,
        "ngawi": null,
        "madiun": null,
        "ponorogo": null,
        "jombang": null,
        "surabaya": null,
        "malang": null
    };

    const tourism = {
        "bandung": ["GdSate", "tangkuban-perahu", "kawah-putih"],
        "jakarta": ["kalijodo", "dufan", "mangrove"],
        "karawang": ["danau-cipule"],
        "indramayu": ["pulau-biawak", "pantai-tirtamaya"],
        "cirebon": ["masjid-agung", "telaga-remis"],
        "brebes": ["kalibaya-park", "curug-panyusuhan"],
        "pekalongan": ["museum-batik", "pantai-pasirkencana"],
        "garut": ["komplek-pemandian", "kampung-sampireun"],
        "tasikmalaya": ["tonjong-canyon", "curug-arjuna"],
        "purwokerto": ["miniatur-dunia", "baturraden"],
        "magelang": ["candi-borobudur", "gunung-merapi"],
        "boyolali": ["new-selo", "kedung-ombo"],
        "semarang": ["lawang-sewu", "kampung-pelangi"],
        "solo": ["tawangmangu", "museum-colomadu"],
        "jogja": ["malioboro", "keraton"],
        "ngawi": ["kebun-teh-jamus", "fort-van-den-bosch"],
        "madiun": ["suncity-waterpark", "taman-trembesi"],
        "ponorogo": ["gunung-wilis", "telaga-ngebel"],
        "jombang": ["trowulan-museum"],
        "surabaya": ["surabaya-zoo", "tugu-pahlawan", "house-of-sampoerna"],
        "malang": ["museum-angkut", "kusuma-agrowisata", "batu-night-spectacular"]
    };

    $(document).ready(function () {
        $('input#start').autocomplete({
            data: data,
        });

        $('input#goal').autocomplete({
            data: data,
        });

        $('input#goal').on("change", function () {
            $('.city-tour').detach();

            var destination = $('input#goal').val().toLowerCase();

            if (destination in data) {
                var attractions = tourism[destination];
                $.each(attractions, function (i, attraction) {
                    var temp = attraction
                    var tour = temp.replace(/-/g, " ");

                    $('.tourism').append(
                        '<div class="col s6 city-tour">' +
                        '        <div style="font-size:10px;" class="btn waves-effect waves-light btn-tourism" name="action">' +
                        '           <span>' + tour + '</span>' +
                        '           <div id="tourism-hidden" hidden>' + attraction + '</div>' +
                        '         </div>' +
                        '</div>')
                });

                var btns = document.getElementsByClassName("btn-tourism");

                for (var i = 0; i < btns.length; i++) {
                    btns[i].addEventListener("click", function () {
                        var current = document.getElementsByClassName("selected");

                        // If there's no active class
                        if (current.length > 0) {
                            current[0].className = current[0].className.replace(" selected", "");
                        }

                        // Add the active class to the current/clicked button
                        this.className += " selected";
                    });
                }
            }
        });

        $('#find').on("submit", function () {
            event.preventDefault();
            getMap();

        });

        function getMap() {
            $.ajax({
                url: {% url 'search' %},
                data: {
                    start: $('#start').val(),
                    goal: $('#goal').val(),
                    tourism: $('#tourism-hidden').text()
                },
                type: 'POST',
                success: function (data) {
                    console.log(data);
                    newMap(data);
                    $('.search').detach();

                    var url = "/destination/" + data.dest_city + "/" + data.tourism + "/";

                    $('#finder').append('<a class="btn-large waves-effect waves-light search" style="margin-left:25%;" href="' + url + '">\n' +
                        '                               LIHAT DETAIL<i class="material-icons right">location_on</i>\n' +
                        '                            </a>');

                }, error: function (msg) {
                    console.log(msg);
                }
            });
        }
    });
</script>
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/leaflet/0.7.7/leaflet.css"/>
<script src="https://cdnjs.cloudflare.com/ajax/libs/leaflet/0.7.7/leaflet.js"></script>
<script src="https://www.mapquestapi.com/sdk/leaflet/v2.2/mq-map.js?key=JVhwB8XrkSjPs6PrreSRgjYUBYlm0r4a"></script>
<script src="https://www.mapquestapi.com/sdk/leaflet/v2.2/mq-routing.js?key=JVhwB8XrkSjPs6PrreSRgjYUBYlm0r4a"></script>


<script>
    var mymap = L.map('map', {
        layers: MQ.mapLayer(),
        center: [-7.614529, 110.712246],
        zoom: 7
    });

    L.tileLayer('https://api.tiles.mapbox.com/v4/{id}/{z}/{x}/{y}.png?access_token={accessToken}', {
        attribution: 'Map data &copy; <a href="https://www.openstreetmap.org/">OpenStreetMap</a> contributors, <a href="https://creativecommons.org/licenses/by-sa/2.0/">CC-BY-SA</a>, Imagery © <a href="https://www.mapbox.com/">Mapbox</a>',
        maxZoom: 9,
        id: 'mapbox.streets',
        accessToken: 'pk.eyJ1IjoibmF1ZmFsaWhzYW4iLCJhIjoiY2pvOGhjaDl5MTNvaTN3cHVncmU4bWFjaSJ9.AlB4TqOHs7enzHARvxO2Nw'
    }).addTo(mymap);
</script>
<script>
    function newMap(data) {

        mymap.setView(new L.LatLng((data.start_lat + data.goal_lat) / 2, (data.start_lng + data.goal_lng) / 2), 8);

        dir = MQ.routing.directions();


        console.log(data.path_coord);

        dir.route({
            locations: data.path_coord
        });


        mymap.addLayer(MQ.routing.routeLayer({
            directions: dir,
            fitBounds: true
        }));

        sessionStorage.setItem("route", data.path);
    }
</script>
</body>
</html>